'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var loom = require('@shopify/loom');

function babel({
  config
} = {}) {
  return loom.createProjectPlugin('Babel', ({
    tasks: {
      dev,
      build,
      test
    }
  }) => {
    const addBabelHooks = loom.addHooks(() => ({
      babelConfig: new loom.WaterfallHook()
    }));
    const addBabelConfig = hookFromConfig(config);
    test.hook(({
      hooks
    }) => {
      hooks.configureHooks.hook(addBabelHooks);
      hooks.configure.hook(configure => {
        var _configure$babelConfi;

        (_configure$babelConfi = configure.babelConfig) === null || _configure$babelConfi === void 0 ? void 0 : _configure$babelConfi.hook(addBabelConfig);
      });
    });
    build.hook(({
      hooks
    }) => {
      hooks.configureHooks.hook(addBabelHooks);
      hooks.target.hook(({
        hooks
      }) => {
        hooks.configure.hook(configure => {
          var _configure$babelConfi2;

          (_configure$babelConfi2 = configure.babelConfig) === null || _configure$babelConfi2 === void 0 ? void 0 : _configure$babelConfi2.hook(addBabelConfig);
        });
      });
    });
    dev.hook(({
      hooks
    }) => {
      hooks.configureHooks.hook(addBabelHooks);
      hooks.configure.hook(configure => {
        var _configure$babelConfi3;

        (_configure$babelConfi3 = configure.babelConfig) === null || _configure$babelConfi3 === void 0 ? void 0 : _configure$babelConfi3.hook(addBabelConfig);
      });
    });
  });
}

function hookFromConfig(config) {
  if (!config) {
    // if config is absent then don't modify the existing hook value
    return arg => arg;
  } else if (typeof config === 'function') {
    // if config is function then modify the existing hook value
    return config;
  } else {
    // if config is an object then override the existing hook value
    return () => config;
  }
}

exports.babel = babel;
