import { WaterfallHook } from '@shopify/loom';
import type { TransformOptions } from '@babel/core';
interface BabelConfig extends Omit<TransformOptions, 'include' | 'exclude'> {
}
interface BabelHooks {
    readonly babelConfig: WaterfallHook<BabelConfig>;
}
declare module '@shopify/loom' {
    interface TestProjectConfigurationCustomHooks extends BabelHooks {
    }
    interface BuildProjectConfigurationCustomHooks extends BabelHooks {
    }
    interface DevProjectConfigurationCustomHooks extends BabelHooks {
    }
}
declare type BabelConfigBuilder = (babelConfig: BabelConfig) => BabelConfig;
interface Options {
    config?: BabelConfig | BabelConfigBuilder;
}
export declare function babel({ config }?: Options): import("@shopify/loom").ProjectPlugin<import("@shopify/loom").WebApp | import("@shopify/loom").Service | import("@shopify/loom").Package>;
export {};
//# sourceMappingURL=plugin-babel.d.ts.map